Множественное наследование и исключения

Хороший пример real-life кода на Python, эксплуатирующий метаклассы и многое другое: enum (в частности, How are Enums different?

Немного про метаклассы:

<!> Не путать с наследованием!

Множественное наследование

Соответственно, нет решения для:

   1 class A: pass
   2 class B(A): pass
   3 class X(A,B): pass

Потому что A, [B] A → , X [A] [B, A] [A, B] ?

Зато есть для class X(B, A): …

Потому что A, [B] A → BA, X [A] [B, A] [B, A]

<!> super(): как всегда — объект-прокси всех методов родительских классов, в случае множественного наследования аналогов не имеет (это как бы объект несуществующего класса, в котором проделан MRO, но ещё нет ни одного поля нашего класса)

   1 class A:
   2     def __new__(cls, *args):
   3     ¦   print(f"New A: {cls}, {args}")
   4     ¦   return super().__new__(cls, *args)
   5 
   6     def f(self):
   7     ¦   return f"A: {self}"
   8 
   9     def __str__(self):
  10     ¦   return f"<{type(self).__name__}>"
  11 
  12 class B:
  13     def __new__(cls, *args):
  14     ¦   print(f"New B: {cls}, {args}")
  15     ¦   return super().__new__(cls, *args)
  16 
  17     def g(self):
  18     ¦   return f"G: {self}"
  19 
  20     def __str__(self):
  21     ¦   return f"<<{type(self).__name__}>>"
  22 
  23 class AB(A, B):
  24     def __new__(cls, *args):
  25     ¦   print(f"New: {cls}, {args}")
  26     ¦   return super().__new__(cls, *args)
  27 
  28 ab = AB()
  29 print(ab, ab.f(), ab.g())

New: <class '__main__.AB'>, ()
New A: <class '__main__.AB'>, ()
New B: <class '__main__.AB'>, ()
<AB> A: <AB> G: <AB>

Обратите внимание на вызов обоих __new__() из super().__new__

Исключения

Исключения – это механизм управления вычислительным потоком, который завязан на разнесении по коду проверки свойств данных и обработки результатов этой проверки.

Синтаксическая ошибка SyntaxError — не обрабатывается (ещё такие ошибки?)

Оператор try:

Оператор raise

Исключения — не «ошибки», а способ обработки некоторых условий не так, где они были обнаружены.

Пример:

   1 class Exc1(Exception): pass
   2 class Exc2(Exception): pass
   3 
   4 def funerr(a,b):
   5     if a<b:
   6         raise Exc1("A must be greater than B")
   7     return a//b
   8 
   9 def justfun(a,b):
  10     if a<b:
  11         raise Exc2("A must be greater than B")
  12     c = funerr(2*a, 3*b)
  13     return c
  14 
  15 for a,b in (10,3),(5,5),(10,0):
  16     try:
  17         c = justfun(a,b)
  18     except Exc1:
  19         c = -1
  20     except Exc2:
  21         c = -2
  22     except ZeroDivisionError:
  23         c = -3
  24     print(c)

Исключения порождаются в разных местах, а обрабатываются в одном:

Оператор with (если успеем)

Например, with open("file") as f: …

Или (сначала сделать простой вариант, без __init__ и raise)

Далее см. contextlib.html

Д/З

  1. Прочитать про исключения в учебнике и в справочнике про исключения, try и raise

  2. EJudge: BoldCalc 'Надёжный калькулятор'

    Написать программу — калькулятор с переменными и обработкой ошибок

    • Команда, начинающаяся на '#' — комментарий
    • Команда вида Переменная=выражение задаёт переменную

    • Команда вида выражение выводит значение выражения.

    • Если команда содержит знак "=", но не является присваиванием, выводится диагностика "invalid assignment" (см. пример)
    • Если слева от "=" находится не идентификатор, выводится диагностика "invalid identifier (см. пример)"
    • В случае любых других ошибок выводится текст ошибки.

    «Выражение» — это произвольное выражение Python3, в котором вдобавок можно использовать уже определённые переменные (и только их). Пробелов в командах нет. Пустая команда или точка означает конец вычислений. Калькулятор вводит и исполняет команды по одной, тут же выводя диагностику, но в тестах это выглядит как ввод последовательности строк и вывод последовательности строк.

    Input:

    42
    100500//33
    "Qq!"*(6-2)
    # Здесь ошибка
    3,,5
    10/(8-8)
    "wer"[2]+"qwe"[1]
    "wer"[7]+"qwe"[9]
    1+(2+(3
    a0=5
    b0=7
    # И здесь ошибка
    12N=12
    # И ещё где-то были
    a0+b0*8
    c=b0//2+a0
    d==100
    c+d
    sorted(dir())
    .
    Output:

    42
    3045
    Qq!Qq!Qq!Qq!
    invalid syntax (<string>, line 1)
    division by zero
    rw
    string index out of range
    unexpected EOF while parsing (<string>, line 1)
    invalid identifier '12N'
    61
    invalid assignment 'd==100'
    name 'd' is not defined
    ['__builtins__', 'a0', 'b0', 'c']

LecturesCMC/PythonIntro2019/12_MultipleInheritanceExceptions (last edited 2020-11-10 15:17:14 by FrBrGeorge)